#include <stdio.h>
#include <stdlib.h>
#include <adc.h>
#include<delays.h>
#include<string.h>
#include<p18f452.h>
#pragma config WDT=OFF,OSC=HS,OSCS=OFF,BORV=45,PWRT=ON,BOR=ON

#define  rs   PORTCbits.RC5
#define  e   PORTCbits.RC7
#define  lcd_data PORTD
#define _XTAL_FREQ 4000000


void Delay_ms(int d);
void pulse(void);
void send_char(unsigned char data);
void lcd_goto(unsigned char data);
void lcd_clr(void);
void send_string(const char *s);
void init_lcd(void);
void dis_num(unsigned int data,unsigned char digit);
void prog1(void);
unsigned long no=0;

char Mamush[]="Heart rate meter";
char Arega[]="H.B.R:    bpm";

void main ()
{
     TRISA=0;
     //TRISB=0;
     TRISAbits.RA2=1;
     init_lcd();
     Delay_ms(10);
    lcd_clr();
    Delay_ms(10);
    send_string(Mamush);
    Delay_ms(1000);
    lcd_clr();
    Delay_ms(10);
     while(1)
     {
     prog1();
     }
    return;
}
void prog1(void)
{
 unsigned int temp1=0,temp2=0;
 unsigned char i;
 unsigned int hb=1;
  while(PORTAbits.RA2);
  while(!PORTAbits.RA2){
  hb++;
  Delay_ms(1);;
  }
 hb=30000/hb;
 lcd_goto(2);
 send_string(Arega);
 lcd_goto(8);
 dis_num(hb,3);

}
void Delay_ms(int d)
{
    int i,j;
    for(i=0;i<d;i++)
    {
        for(j=0;j<d;j++)
        {
        }
    }
}

void send_config(unsigned char data) //send lcd configuration
{
 rs=0;        //set lcd to configuration mode
lcd_data=data&0xf0;     //lcd data port = data
 pulse();
 lcd_data=(data<<4)&0xf0;
 pulse();
}
void pulse(void)
{
 e=1;        //pulse e to confirm the data
 Delay_ms(1);
 e=0;
 Delay_ms(1);
}
void lcd_goto(unsigned char data)  //set the location of the lcd cursor
{          //if the given value is (0-15) the
     send_config(0x80+data);   //cursor will be at the lower line
}
void lcd_clr(void)      //clear the lcd
{

send_config(0x01);
 Delay_ms(2);
}
void send_string(const char *s)   //send a string to display in the lcd
{
rs = 1;
while (*s)send_char (*s++);
}
void send_char(unsigned char data)  //send lcd character
{
rs =1;
Delay_ms(1);        //set lcd to display mode
 lcd_data=data&0xf0;     //lcd data port = data
 pulse();
 lcd_data=(data<<4)&0xf0;
 pulse();
}
void init_lcd(void)
{
 rs=0;
 e=0;        //command mode
 Delay_ms(10);      //delay 10ms
 lcd_data=0x30;      //load initial nibble
 pulse();       //Latch initial code
 Delay_ms(5);       //delay 5ms
 pulse();       //Latch initial code
 Delay_ms(1);       //delay 1ms
 pulse();       //Latch initial code
 lcd_data=0x20;
 pulse();       //Latch initial code

 //configure lcd
 send_config(0x28);     //Set 4-bit mode, 2 lines
 send_config(0xF);     //Switch off display
  send_config(0x06);     //Enable cursor auto increase
}
void dis_num(unsigned int data,unsigned char digit)
{
 if(digit>3)
 send_char('0'+(data/1000)%10);
 if(digit>2)
 send_char('0'+(data/100)%10);
 if(digit>1)
 send_char('0'+(data/10)%10);
 if(digit>0)
 send_char('0'+(data/1)%10);
}


